var lWarn = {logln:function (o){}};
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "sr-config.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

var Utf8 = {
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    }
};

function startup() {
    // Prepare app
    Property.load();
    var version = '1.0.8',
        propVersion = Property.getNode('version');
    lInfo.logln("startup scene-responder");

    if (propVersion) {
        var currentVersion = propVersion.getValue();
        if (isPropertyTreeNotCurrent(currentVersion, '0.4') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 0.4");
            convertOldTriggers();
            currentVersion = '0.4';
        }
        if (isPropertyTreeNotCurrent(currentVersion, '1.0.3') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 1.0.3");
            updateData();
            currentVersion = '1.0.3';
        }
        if (isPropertyTreeNotCurrent(currentVersion, '1.0.4') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 1.0.4");
            updateScope();
            currentVersion = '1.0.4';
        }
        if (isPropertyTreeNotCurrent(currentVersion, '1.0.5') < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to 1.0.5");
            updatePersistentScope();
            currentVersion = '1.0.5';
        }
        lInfo.logln("Check convertion from version " + currentVersion + " to " + version);
        if (isPropertyTreeNotCurrent(currentVersion, version) < 0 ) {
            lInfo.logln("Converting from version " + currentVersion + " to " + version);
            updateDSID2DSUID();
            currentVersion = '1.0.7';
        }
    }
    updateAllTrigger();

    if (!Property.getNode('entries')) {
        var nd = new Property('entries');
        nd.setFlag('ARCHIVE', true);
    }

    //checkAndDeleteObsoleteSREntries();

    //set version number
    Property.setProperty('version', version);
    Property.setFlag('version', 'ARCHIVE', true);
    Property.store();
    lInfo.logln("scene-responder running (Version " + version + ")");
    
}

function checkAndDeleteObsoleteSREntries() {
	var fMigrate=false;
	lInfo.logln('Checke nach SR Eintraege, die zu Apps gehren, die schon deinstalliert sind');
	var basePropertyArray = Property.getNode('entries');
	if (basePropertyArray!=null) {
       var subPropArray = basePropertyArray.getChildren();
       for ( var iIndex = 0; iIndex < subPropArray.length; iIndex++) {
           lInfo.logln('checkAndDeleteObsoleteSREntries values found ' + iIndex);
           if (subPropArray[iIndex].getChild('persistentScope').getValue()==false) {
               var sName=subPropArray[iIndex].getChild('scope').getValue();
               lInfo.logln('check ' + sName + " v " + Property.getNode('/scripts/'+ sName)); 
                
        	   if (Property.getNode('/scripts/'+ sName)  == null) {
        		   	lWarn.logln('Remove ' + subPropArray[iIndex].getName());
       	        	basePropertyArray.removeChild(subPropArray[iIndex].getName());       	        	
    	            unregisterTrigger(basePropertyArray.getPath() + "/" + subPropArray[iIndex].getName());
       	        	
       	        	fMigrate=true;
        	   }
           }
       }
   }
	   
   if (fMigrate)
       Property.store();
   else
       lInfo.logln('nothing to update - checkAndDeleteObsoleteSREntries');
}


function putConditionParameter(idValue,oParameterObject) {
	var succeded = true;
	if (oParameterObject.conditions==null)
		return succeded;
	var sSubpath=idValue + '/conditions/';
	if (oParameterObject.conditions.enabled!=null) {
		if (oParameterObject.conditions.enabled==true)
			storeSubParameter(sSubpath + 'enabled', true);
		else 
			storeSubParameter(sSubpath + 'enabled', false);
	}	
	if (oParameterObject.conditions.weekdays!=null) {
		var sString="";
		for (var iIndex=0;iIndex<oParameterObject.conditions.weekdays.length;iIndex++) {
			var sWeekday=oParameterObject.conditions.weekdays[iIndex];
			switch (sWeekday)
			{
				case 'SU':
					sString += '0,';
				break;
				case 'MO':
					sString += '1,';
				break;
				case 'TU':
					sString += '2,';
				break;
				case 'WE':
					sString += '3,';
				break;
				case 'TH':
					sString += '4,';
				break;
				case 'FR':
					sString += '5,';
				break;
				case 'SA':
					sString += '6,';
				break;
			}	
		}
		if (sString!="") {
			sString=sString.substr(0,sString.length-1);
			storeSubParameter(sSubpath + 'weekdays', sString);
		}
	}	
	if (oParameterObject.conditions.systemState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.systemState.length;iIndex++){
			var sStateName=oParameterObject.conditions.systemState[iIndex].name;
			var sStateValue=oParameterObject.conditions.systemState[iIndex].value;
			if (sStateValue==='false')
				sStateValue=false;
			if (sStateValue==='true')
				sStateValue=true;
			storeSubParameter(sSubpath + 'states/' + sStateName,sStateValue);
		}
	}	
	if (oParameterObject.conditions.addonStates!=null) {
		for (var sAddonId in oParameterObject.conditions.addonStates) {
			for (var iIndex=0;iIndex<oParameterObject.conditions.addonStates[sAddonId].length;iIndex++){
				var sStateName=oParameterObject.conditions.addonStates[sAddonId][iIndex].name;
				var sStateValue=oParameterObject.conditions.addonStates[sAddonId][iIndex].value;
				if (sStateValue==='false')
					sStateValue=2;
				if (sStateValue==='true')
					sStateValue=1;
				if (sStateValue===false)
					sStateValue=2;
				if (sStateValue===true)
					sStateValue=1;
				storeSubParameter(sSubpath + 'addon-states/' + sAddonId + '/' + sStateName,sStateValue);
			}
		}
	}	
	if (oParameterObject.conditions.zoneState!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.zoneState.length;iIndex++){ 
			var zoneID=oParameterObject.conditions.zoneState[iIndex].zone;
			var groupID=oParameterObject.conditions.zoneState[iIndex].group;
			var sceneID=oParameterObject.conditions.zoneState[iIndex].scene;
			
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/zone' , zoneID) ? succeded : false;
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/group' , groupID) ? succeded : false;
			succeded = checkAndStoreIntParameter(sSubpath + 'zone-states/' + iIndex + '/scene' , sceneID) ? succeded : false;
		}
	}	
	if (oParameterObject.conditions.timeframe!=null) {
		for (var iIndex=0;iIndex<oParameterObject.conditions.timeframe.length;iIndex++){ 
			var from=oParameterObject.conditions.timeframe[iIndex].start;
			var to=oParameterObject.conditions.timeframe[iIndex].end;
			var sFromBase=from.timeBase;
			var sFromOffset=from.offset;
			var sToBase=to.timeBase;
			var sToOffset=to.offset;
			lInfo.logln('from ' + sFromBase + ' off ' + sFromOffset + ' to  ' + sToBase + ' off ' + sToOffset);
			if (sFromBase=='daily')
				if (sToBase=='daily'){
					storeSubParameter(sSubpath + 'time-start' , Math.floor(parseInt("" + sFromOffset,10)/3600) + ':' + Math.floor(parseInt("" + sFromOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sFromOffset,10)%60));
					storeSubParameter(sSubpath + 'time-end'  , Math.floor(parseInt("" + sToOffset,10)/3600) + ':' + Math.floor(parseInt("" + sToOffset,10)/60)%60 + ':' + Math.floor(parseInt("" + sToOffset,10)%60));
				}
		}	
	}		
	return succeded;
}

function putTriggerParameter(idValue,oParameterObject) {
	var succeded = true;
	var iIndex;
    for (iIndex=0;iIndex<oParameterObject.triggers.length;iIndex++)
    {
        var sSubpath=idValue + '/triggers/' + (iIndex + 1) + "/";
        switch(oParameterObject.triggers[iIndex].type) {       
            case 'zone-scene':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene) ? succeded : false;
                if (oParameterObject.triggers[iIndex].forced!=null)
                	succeded = checkAndStoreBoolParameter(sSubpath + "forced" , oParameterObject.triggers[iIndex].forced) ? succeded : false;
                storeSubParameter(sSubpath + "dsuid" , -1);
                break;
            case 'undo-zone-scene':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "zone" , oParameterObject.triggers[iIndex].zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "group" , oParameterObject.triggers[iIndex].group) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene) ? succeded : false;
                storeSubParameter(sSubpath + "dsid" , -1);
                break;
            case 'device-msg':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(sSubpath + "dsuid" , oParameterObject.triggers[iIndex].dsuid, oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "msg" , oParameterObject.triggers[iIndex].msg) ? succeded : false;
                if (oParameterObject.triggers[iIndex].buttonIndex!=null)
                	succeded = checkAndStoreIntParameter(sSubpath + "buttonIndex" , oParameterObject.triggers[iIndex].buttonIndex) ? succeded : false;
                break;
            case 'device-binary-input':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "index" , oParameterObject.triggers[iIndex].index) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state) ? succeded : false;
                break;
            case 'device-scene':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(sSubpath + "dsuid" , oParameterObject.triggers[iIndex].dsuid, oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "scene" , oParameterObject.triggers[iIndex].scene) ? succeded : false;
                break;
            case 'custom-event':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(sSubpath + "event" , oParameterObject.triggers[iIndex].event) ? succeded : false;
                break;
            case 'device-sensor':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(sSubpath + "dsid" , oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(sSubpath + "dsuid" , oParameterObject.triggers[iIndex].dsuid, oParameterObject.triggers[iIndex].dsid) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "eventid" , oParameterObject.triggers[iIndex].eventid) ? succeded : false;
                break;
            case 'state-change':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "name" , oParameterObject.triggers[iIndex].name) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state) ? succeded : false;
                break;
            case 'addon-state-change':
            	succeded = checkAndStoreStringParameter(sSubpath + "type" , oParameterObject.triggers[iIndex].type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "addon-id" , oParameterObject.triggers[iIndex].addonId) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "name" , oParameterObject.triggers[iIndex].name) ? succeded : false;
            	succeded = checkAndStoreStringParameter(sSubpath + "state" , oParameterObject.triggers[iIndex].state) ? succeded : false;
                break;
        }
    }
    return succeded;
}

function putActionParameter(idValue,oParameterObject) {
	var iIndex;
	var succeded = true;
    for (iIndex = 0; iIndex < oParameterObject.actions.length; iIndex++) {
        var oSubobject = oParameterObject.actions[iIndex];
        switch (oSubobject.type) {
		    case 'heating-mode':
		    	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false ;
		    	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false ;
		    	if (oSubobject.reset!=null)
		    		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/reset', oSubobject.reset) ? succeded : false;
		    	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/mode', oSubobject.mode) ? succeded : false;
		    break;
		    case 'zone-scene':
		    	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false ;
		    	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false ;
		    	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group) ? succeded : false ;
		    	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene) ? succeded : false;
		    	if (oSubobject.force!=null)
		    		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force) ? succeded : false;
		    break;
            case 'undo-zone-scene':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene) ? succeded : false;
            	if (oSubobject.force!=null)
            		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force) ? succeded : false;
            break;
            case 'device-scene':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(idValue + '/actions/' + iIndex + '/dsuid' , oSubobject.dsuid, oSubobject.dsid) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/scene', oSubobject.scene) ? succeded : false;
            	if (oSubobject.force!=null)
            		succeded = checkAndStoreBoolParameter(idValue + '/actions/' + iIndex + '/force', oSubobject.force) ? succeded : false;
            break;
            case 'device-value':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/value', oSubobject.value) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(idValue + '/actions/' + iIndex + '/dsuid' , oSubobject.dsuid, oSubobject.dsid) ? succeded : false;
            break;
            case 'device-blink':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	//succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/dsid', oSubobject.dsid) ? succeded : false;
            	succeded = checkAndStoreDSUIDParameter(idValue + '/actions/' + iIndex + '/dsuid' , oSubobject.dsuid, oSubobject.dsid) ? succeded : false;
            break;
            case 'zone-blink':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/zone', oSubobject.zone) ? succeded : false;
            	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/group', oSubobject.group) ? succeded : false;
            break;
            case 'custom-event':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/event', oSubobject.event) ? succeded : false;
            break;
            case 'url':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
                oSubobject.url = oSubobject.url.replace(/&amp;/g, '&');
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/url', Utf8.encode(unescape(oSubobject.url))) ? succeded : false;
            break;
            case 'change-state':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	if (oSubobject.name!=null)
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.name) ? succeded : false;
            	else
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.statename) ? succeded : false;

               succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/state" , oSubobject.state);
            break;            
            case 'change-addon-state':
            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + '/type', oSubobject.type) ? succeded : false;
            	if (oSubobject.name!=null)
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.name) ? succeded : false;
            	else
            		succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/statename" , oSubobject.statename) ? succeded : false;

            	succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/addon-id" , oSubobject.addonId) ? succeded : false;
                succeded = checkAndStoreStringParameter(idValue + '/actions/' + iIndex + "/state" , oSubobject.state) ? succeded : false;
            break;
            default:
            	//unexpected type 
            	succeded = false;
            break;
        }
        if (oSubobject.delay!=null) {
        	succeded = checkAndStoreIntParameter(idValue + '/actions/' + iIndex + '/delay', oSubobject.delay) ? succeded : false;
        }
        storeSubParameter(idValue + '/actions/' + iIndex + '/category', 'manual');
    }
    return succeded;
}

function getNewIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('entries');
    if (baseNode == null) {
        return idValue;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null) {
            if (oChildNode.getChild('id').getValue() != null) {
                if (parseInt("" + oChildNode.getChild('id').getValue(), 10) >= idValue) {
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(), 10) + 1;
                }
            }
        }
    }
    return idValue;
}

function storeValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        
        if (oParameterObject.id != null) {
        	idValue = oParameterObject.id;  
        } else {
            idValue = getNewIdValue();
        }

        var baseNode = Property.getNode('entries');
        if (baseNode != null) {
            baseNode.removeChild(idValue);
        }
        //the unescape already ensures to be string
        storeSubParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeSubParameter(idValue + '/id', idValue);
        storeSubParameter(idValue + '/conditions/enabled', true);

        if (!putActionParameter(idValue,oParameterObject)) throw "wrong argument types";
        if (!putTriggerParameter(idValue,oParameterObject)) throw "wrong argument types";
        if (!putConditionParameter(idValue,oParameterObject)) throw "wrong argument types";
        if (!checkAndStoreIntParameter(idValue + '/delay', oParameterObject.delay)) throw "wrong argument types";
                
        storeSubParameter(idValue + '/singularTriggered', false);
        if (oParameterObject.singularTriggered!=null)
            if (oParameterObject.singularTriggered)
                    storeSubParameter(idValue + '/singularTriggered', true);
        storeSubParameter(idValue + '/initialTriggered', false);
        if (oParameterObject.initialTriggered!=null)
            if (oParameterObject.initialTriggered)
                    storeSubParameter(idValue + '/initialTriggered', true);
        
        if (oParameterObject.scope!=null) {
        	if (!checkAndStoreStringParameter(idValue + '/scope',oParameterObject.scope)) throw "wrong argument types";
        } else {
        	storeSubParameter(idValue + '/scope','system-addon-scene-responder');
        }
        
        if (oParameterObject.persistentScope !=null) {
        	storeSubParameter(idValue + '/persistentScope',oParameterObject.persistentScope );
        } else {
        	storeSubParameter(idValue + '/persistentScope',true);
        }
        
        if (oParameterObject.metaData!=null) {
        	if (!checkAndStoreStringParameter(idValue + '/metaData', oParameterObject.metaData)) throw "wrong argument types";
        }
        
        //Property.store();
        updateTriggerRegistration(Property.getNode('entries/' + idValue));
        return true;
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }
        //we could not store all data successfully so we cleanup
        baseNode.removeChild(idValue);
        return false;
    }
}

function updateAllTrigger()
{
    var baseNode = Property.getNode('entries');
    if (baseNode == null) {
        lInfo.logln("SR-Config update all trigger : no entries");
        return;
    }
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        lInfo.logln("SR-Config Set Trigger" + iIndex);
        var oChildNode = oArrayNode[iIndex];
        updateTriggerRegistration(oChildNode);
    }
}

function updateTriggerRegistration(oChildNode)
{
    var oParameter={};
    try {
        if (oChildNode.getChild('singularTriggered')!=null)
            if (oChildNode.getChild('singularTriggered').getValue()) {
                registerTrigger(oChildNode.getPath(),'system-addon-scene-responder.delayedTrigger',oParameter);
                return;
            }
        if (oChildNode.getChild('initialTriggered')!=null)
            if (oChildNode.getChild('initialTriggered').getValue()) {
                registerTrigger(oChildNode.getPath(),'system-addon-scene-responder.initialTrigger',oParameter);
                return;
            }
        if (oChildNode.getChild("delay")!=null) 
            if (oChildNode.getChild("delay").getValue()!=0){
                oParameter.time = "+" + oChildNode.getChild("delay").getValue();
            }
        
        registerTrigger(oChildNode.getPath(),'action_execute',oParameter);
    } catch (e) {
        lWarn.logln("Fehler beim registerTrigger: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    } 
}

if (raisedEvent.name == 'system-addon-scene-responder.config') {
	Property.load();
    lInfo.logln("SR-Config param action " + raisedEvent.parameter.actions);
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("SR-Config param value " + unescape(raisedEvent.parameter.value));
        var success = storeValue(raisedEvent.parameter.value);
        Property.store();
        var evt;
        if (success) {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'success'});
        } else {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'failed'});
        }
        evt.raise();
    }
    
    if (raisedEvent.parameter.actions == 'saveMultiple') {
        lInfo.logln("SR-Config param Array " + unescape(raisedEvent.parameter.value));
        var oParameterArray = JSON.parse(unescape(raisedEvent.parameter.value));
        var fSuccess=true;
        for (var iIndex=0;iIndex<oParameterArray.length;iIndex++) {
        	lInfo.logln("SR-Config param Array # " + (iIndex+1));
            if (!storeValue(escape(JSON.stringify(oParameterArray[iIndex]))))
            	fSuccess=false;
        }
        Property.store();
        if (success) {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'success'});
        } else {
        	evt = new Event("system-addon-scene-responder.saved", {complete:'failed'});
        }
        evt.raise();
    }
    
    if (raisedEvent.parameter.actions == 'enable') {
        lInfo.logln("SR-Config enable value " + raisedEvent.parameter.id);

        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        lWarn.logln(typeof(oIDObject));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	 lInfo.logln("SR-Config enable subvalue " + oIDObject[sKey] );
	        var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	            storeSubParameter(oIDObject[sKey] + '/conditions/enabled', true);
	        }
        }
        
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'disable') {
        lInfo.logln("SR-Config disable value " + raisedEvent.parameter.id);
        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
	        var sanityCheck = Property.getNode('entries/'+oIDObject[sKey]);
	        if (sanityCheck != null) {                
	            storeSubParameter(oIDObject[sKey] + '/conditions/enabled', false);
	        }
        }
        
        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("SR-Config delete value " + raisedEvent.parameter.id);

        
        var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
        if (typeof(oIDObject)!='object')
            oIDObject=[oIDObject];

        for (var sKey in oIDObject) {
        	var baseNode = Property.getNode('entries');
	        if (baseNode != null) {
	            baseNode.removeChild(oIDObject[sKey]);
	            unregisterTrigger(baseNode.getPath() + "/" + oIDObject[sKey]);
	        }
        }

        Property.store();
        var evt = new Event("system-addon-scene-responder.saved", {});
        evt.raise();
    }
} else if (raisedEvent.name == 'running') {
    startup();
    var evt = new Event("system-addon-scene-responder.cleanup", {'time':'+5'});
    evt.raise();
} else if (raisedEvent.name == 'system-addon-scene-responder.cleanup') {
	checkAndDeleteObsoleteSREntries();
}

